<template>
  <v-btn-toggle
    v-if="$store.state.debugMode"
    v-model="subTableToggle"
    mandatory
  >
    <v-btn
      @click="(e) => handleButton(e, 'null')"
    >
      -
    </v-btn>

    <v-btn
      v-for="(k, index) in repeats"
      :key="index"
      @click="(e) => handleButton(e, k)"
    >
      {{ k }}
    </v-btn>
    <v-btn @click="addRepeat">
      +
    </v-btn>
  </v-btn-toggle>
</template>

<script lang="ts">
import type { Second, Unit } from '@/data';
import type SynchronizationActions from '@/synchronization-logic/SynchronizationActions';
import { Component, Prop, Vue } from 'vue-property-decorator';

@Component
export default class SyncRepeats extends Vue {
  @Prop({ required: true })
  secondUnit!: Unit<Second>;

  @Prop()
  actions!: SynchronizationActions;

  subTableToggle = 0;

  repeats: Array<string> = [];

  mounted() {
    this.refreshRepeats();
  }

  hasRepeat(repeat: string): boolean {
    return this.secondUnit.hasRepeat(repeat);
  }

  refreshRepeats() {
    const keys = Object.keys(this.secondUnit.repeatTables);
    keys.splice(keys.findIndex((k) => k === 'null'), 1).sort();
    this.repeats = keys;
  }

  async addRepeat() {
    this.secondUnit.addRepeat();
    this.refreshRepeats();
  }

  handleButton(e: MouseEvent, k: string) {
    let labelId = null;
    if (e.shiftKey) {
      const label = this.actions.getSelected();
      if (label) {
        labelId = label.id;
        this.actions
          .setSyncPoint(label.id, [label.point[0], label.point[1], k]);
      }
    }
    this.$store.dispatch('synchro/updateCurrentRepeat', k);
    this.$emit('reset-sync', k);

    if (labelId) this.actions.select(labelId);
  }
}
</script>
